diff -x CVS -x wntmsci3 -x wntmsci7 -x wntmsci8 -urN ooo_SRC680_m233_src.orig/vcl/aqua/inc/salframeview.h ooo_SRC680_m233_src.aquavcl04/vcl/aqua/inc/salframeview.h
--- ooo_SRC680_m233_src.orig/vcl/aqua/inc/salframeview.h	1970-01-01 01:00:00.000000000 +0100
+++ ooo_SRC680_m233_src.aquavcl04/vcl/aqua/inc/salframeview.h	2007-10-16 15:10:08.000000000 +0200
@@ -0,0 +1,109 @@
+/*************************************************************************
+ *
+ *  OpenOffice.org - a multi-platform office productivity suite
+ *
+ *  $RCSfile$
+ *
+ *  $Revision$
+ *
+ *  last change: $Author$ $Date$
+ *
+ *  The Contents of this file are made available subject to
+ *  the terms of GNU Lesser General Public License Version 2.1.
+ *
+ *
+ *    GNU Lesser General Public License Version 2.1
+ *    =============================================
+ *    Copyright 2005 by Sun Microsystems, Inc.
+ *    901 San Antonio Road, Palo Alto, CA 94303, USA
+ *
+ *    This library is free software; you can redistribute it and/or
+ *    modify it under the terms of the GNU Lesser General Public
+ *    License version 2.1, as published by the Free Software Foundation.
+ *
+ *    This library is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ *    Lesser General Public License for more details.
+ *
+ *    You should have received a copy of the GNU Lesser General Public
+ *    License along with this library; if not, write to the Free Software
+ *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ *    MA  02111-1307  USA
+ *
+ ************************************************************************/
+
+#ifndef _VCL_SALFRAMEVIEW_H
+#define _VCL_SALFRAMEVIEW_H
+
+@interface SalFrameWindow : NSWindow
+{
+    AquaSalFrame*       mpFrame;
+}
+-(id)initWithSalFrame: (AquaSalFrame*)pFrame;
+-(void)windowDidBecomeKey: (NSNotification*)pNotification;
+-(void)windowDidResignKey: (NSNotification*)pNotification;
+-(void)windowDidChangeScreen: (NSNotification*)pNotification;
+-(void)windowDidMove: (NSNotification*)pNotification;
+-(void)windowDidResize: (NSNotification*)pNotification;
+-(void)windowDidMiniaturize: (NSNotification*)pNotification;
+-(void)windowDidDeminiaturize: (NSNotification*)pNotification;
+-(MacOSBOOL)windowShouldClose: (NSNotification*)pNotification;
+-(void)dockMenuItemTriggered: (id)sender;
+-(AquaSalFrame*)getSalFrame;
+@end
+
+@interface SalFrameView : NSView <NSTextInput>
+{
+    AquaSalFrame*       mpFrame;
+
+    // for NSTextInput
+    id mpLastEvent;
+    BOOL mbNeedSpecialKeyHandle;
+    BOOL mbInKeyInput;
+    BOOL mbKeyHandled;
+    NSRange mMarkedRange;
+    NSRange mSelectedRange;
+}
++(void)unsetMouseFrame: (AquaSalFrame*)pFrame;
+-(id)initWithSalFrame: (AquaSalFrame*)pFrame;
+-(MacOSBOOL)acceptsFirstResponder;
+-(MacOSBOOL)acceptsFirstMouse: (NSEvent *)pEvent;
+-(MacOSBOOL)isOpaque;
+-(void)drawRect: (NSRect)aRect;
+-(void)mouseDown: (NSEvent*)pEvent;
+-(void)mouseDragged: (NSEvent*)pEvent;
+-(void)mouseUp: (NSEvent*)pEvent;
+-(void)mouseMoved: (NSEvent*)pEvent;
+-(void)mouseEntered: (NSEvent*)pEvent;
+-(void)mouseExited: (NSEvent*)pEvent;
+-(void)rightMouseDown: (NSEvent*)pEvent;
+-(void)rightMouseDragged: (NSEvent*)pEvent;
+-(void)rightMouseUp: (NSEvent*)pEvent;
+-(void)otherMouseDown: (NSEvent*)pEvent;
+-(void)otherMouseDragged: (NSEvent*)pEvent;
+-(void)otherMouseUp: (NSEvent*)pEvent;
+-(void)scrollWheel: (NSEvent*)pEvent;
+-(void)keyDown: (NSEvent*)pEvent;
+-(void)flagsChanged: (NSEvent*)pEvent;
+-(void)sendMouseEventToFrame:(NSEvent*)pEvent button:(USHORT)nButton eventtype:(USHORT)nEvent;
+-(void)sendKeyInputAndReleaseToFrame: (USHORT)nKeyCode character: (sal_Unicode)aChar;
+-(MacOSBOOL)checkSpecialCharacters:(NSEvent*)pEvent;
+/*
+    text action methods
+*/
+-(void)insertText:(id)aString;
+-(void)insertTab: (id)aSender;
+-(void)moveLeft: (id)aSender;
+-(void)moveRight: (id)aSender;
+-(void)moveUp: (id)aSender;
+-(void)moveDown: (id)aSender;
+-(void)insertNewline: (id)aSender;
+-(void)deleteBackward: (id)aSender;
+-(void)deleteForward: (id)aSender;
+-(void)cancelOperation: (id)aSender;
+/* set the correct pointer for our view */
+-(void)resetCursorRects;
+@end
+
+#endif
diff -x CVS -x wntmsci3 -x wntmsci7 -x wntmsci8 -urN ooo_SRC680_m233_src.orig/vcl/aqua/inc/salinst.h ooo_SRC680_m233_src.aquavcl04/vcl/aqua/inc/salinst.h
--- ooo_SRC680_m233_src.orig/vcl/aqua/inc/salinst.h	2007-10-09 17:09:54.000000000 +0200
+++ ooo_SRC680_m233_src.aquavcl04/vcl/aqua/inc/salinst.h	2007-10-23 16:05:13.000000000 +0200
@@ -46,6 +46,7 @@
 #include <list>
 
 class AquaSalFrame;
+class ApplicationEvent;
 
 // -----------------
 // - SalYieldMutex -
@@ -98,9 +99,14 @@
     rtl::OUString                           maDefaultPrinter;
     vos::OThread::TThreadIdentifier         maMainThread;
     int                                     mnMainThreadLevel;
+    bool                                    mbWaitingYield;
     NSAutoreleasePool*                      mpAutoreleasePool;
     std::list< SalUserEvent >               maUserEvents;
     oslMutex                                maUserEventListMutex;
+
+    typedef std::list<const ApplicationEvent*> AppEventList;
+    static AppEventList aAppEventList;
+    
 public:
     AquaSalInstance();
     virtual ~AquaSalInstance();
@@ -147,6 +153,8 @@
     virtual void            SetErrorEventCallback( void* pInstance, bool(*pCallback)(void*,void*,int) );
 
     static void handleAppDefinedEvent( NSEvent* pEvent );
+    
+    void wakeupYield();
 
  public:
     friend class AquaSalFrame;
diff -x CVS -x wntmsci3 -x wntmsci7 -x wntmsci8 -urN ooo_SRC680_m233_src.orig/vcl/aqua/inc/salmenu.h ooo_SRC680_m233_src.aquavcl04/vcl/aqua/inc/salmenu.h
--- ooo_SRC680_m233_src.orig/vcl/aqua/inc/salmenu.h	2007-10-09 17:10:05.000000000 +0200
+++ ooo_SRC680_m233_src.aquavcl04/vcl/aqua/inc/salmenu.h	2007-10-15 15:24:24.000000000 +0200
@@ -85,34 +85,4 @@
     std::vector< AquaSalMenuItem* > maItems;
 };
 
-class AquaSalMenuItem : public SalMenuItem
-{
-public:
-    AquaSalMenuItem( const SalItemParams* );
-    virtual ~AquaSalMenuItem();
-
-    USHORT              mnId;                 // Item ID
-    Menu*               mpVCLMenu;            // VCL Menu into which this MenuItem is inserted
-    AquaSalMenu*        mpParentMenu;         // The menu in which this menu item is inserted
-    AquaSalMenu*        mpSubMenu;            // Sub menu of this item (if defined)
-    NSMenuItem*         mpMenuItem;           // The NSMenuItem
-};
-
-@interface SalNSMenu : NSMenu
-{
-    AquaSalMenu*        mpMenu;
-}
--(id)initWithMenu: (AquaSalMenu*)pMenu;
--(void)menuNeedsUpdate: (NSMenu*)pMenu;
--(void)setSalMenu: (AquaSalMenu*)pMenu;
-@end
-
-@interface SalNSMenuItem : NSMenuItem
-{
-    AquaSalMenuItem*    mpMenuItem;
-}
--(id)initWithMenuItem: (AquaSalMenuItem*)pMenuItem;
--(void)menuItemTriggered: (id)aSender;
-@end
-
 #endif // _SV_SALMENU_H
diff -x CVS -x wntmsci3 -x wntmsci7 -x wntmsci8 -urN ooo_SRC680_m233_src.orig/vcl/aqua/inc/salnsmenu.h ooo_SRC680_m233_src.aquavcl04/vcl/aqua/inc/salnsmenu.h
--- ooo_SRC680_m233_src.orig/vcl/aqua/inc/salnsmenu.h	1970-01-01 01:00:00.000000000 +0100
+++ ooo_SRC680_m233_src.aquavcl04/vcl/aqua/inc/salnsmenu.h	2007-10-15 15:24:24.000000000 +0200
@@ -0,0 +1,70 @@
+/*************************************************************************
+ *
+ *  OpenOffice.org - a multi-platform office productivity suite
+ *
+ *  $RCSfile$
+ *
+ *  $Revision$
+ *
+ *  last change: $Author$ $Date$
+ *
+ *  The Contents of this file are made available subject to
+ *  the terms of GNU Lesser General Public License Version 2.1.
+ *
+ *
+ *    GNU Lesser General Public License Version 2.1
+ *    =============================================
+ *    Copyright 2005 by Sun Microsystems, Inc.
+ *    901 San Antonio Road, Palo Alto, CA 94303, USA
+ *
+ *    This library is free software; you can redistribute it and/or
+ *    modify it under the terms of the GNU Lesser General Public
+ *    License version 2.1, as published by the Free Software Foundation.
+ *
+ *    This library is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ *    Lesser General Public License for more details.
+ *
+ *    You should have received a copy of the GNU Lesser General Public
+ *    License along with this library; if not, write to the Free Software
+ *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ *    MA  02111-1307  USA
+ *
+ ************************************************************************/
+
+#ifndef _VCL_SALNSMENU_H
+#define _VCL_SALNSMENU_H
+
+class AquaSalMenuItem : public SalMenuItem
+{
+public:
+    AquaSalMenuItem( const SalItemParams* );
+    virtual ~AquaSalMenuItem();
+
+    USHORT              mnId;                 // Item ID
+    Menu*               mpVCLMenu;            // VCL Menu into which this MenuItem is inserted
+    AquaSalMenu*        mpParentMenu;         // The menu in which this menu item is inserted
+    AquaSalMenu*        mpSubMenu;            // Sub menu of this item (if defined)
+    NSMenuItem*         mpMenuItem;           // The NSMenuItem
+};
+
+@interface SalNSMenu : NSMenu
+{
+    AquaSalMenu*        mpMenu;
+}
+-(id)initWithMenu: (AquaSalMenu*)pMenu;
+-(void)menuNeedsUpdate: (NSMenu*)pMenu;
+-(void)setSalMenu: (AquaSalMenu*)pMenu;
+@end
+
+@interface SalNSMenuItem : NSMenuItem
+{
+    AquaSalMenuItem*    mpMenuItem;
+}
+-(id)initWithMenuItem: (AquaSalMenuItem*)pMenuItem;
+-(void)menuItemTriggered: (id)aSender;
+@end
+
+
+#endif
diff -x CVS -x wntmsci3 -x wntmsci7 -x wntmsci8 -urN ooo_SRC680_m233_src.orig/vcl/aqua/inc/salnstimer.h ooo_SRC680_m233_src.aquavcl04/vcl/aqua/inc/salnstimer.h
--- ooo_SRC680_m233_src.orig/vcl/aqua/inc/salnstimer.h	1970-01-01 01:00:00.000000000 +0100
+++ ooo_SRC680_m233_src.aquavcl04/vcl/aqua/inc/salnstimer.h	2007-10-15 15:24:24.000000000 +0200
@@ -0,0 +1,48 @@
+/*************************************************************************
+ *
+ *  OpenOffice.org - a multi-platform office productivity suite
+ *
+ *  $RCSfile$
+ *
+ *  $Revision$
+ *
+ *  last change: $Author$ $Date$
+ *
+ *  The Contents of this file are made available subject to
+ *  the terms of GNU Lesser General Public License Version 2.1.
+ *
+ *
+ *    GNU Lesser General Public License Version 2.1
+ *    =============================================
+ *    Copyright 2005 by Sun Microsystems, Inc.
+ *    901 San Antonio Road, Palo Alto, CA 94303, USA
+ *
+ *    This library is free software; you can redistribute it and/or
+ *    modify it under the terms of the GNU Lesser General Public
+ *    License version 2.1, as published by the Free Software Foundation.
+ *
+ *    This library is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ *    Lesser General Public License for more details.
+ *
+ *    You should have received a copy of the GNU Lesser General Public
+ *    License along with this library; if not, write to the Free Software
+ *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ *    MA  02111-1307  USA
+ *
+ ************************************************************************/
+#ifndef _VCL_SALNSTIMER_H
+#define _VCL_SALNSTIMER_H
+
+#include "premac.h"
+#include "Cocoa/Cocoa.h"
+#include "postmac.h"
+
+@interface TimerCallbackCaller : NSObject
+{
+}
+-(void)timerElapsed:(NSTimer*)pTimer;
+@end
+
+#endif
diff -x CVS -x wntmsci3 -x wntmsci7 -x wntmsci8 -urN ooo_SRC680_m233_src.orig/vcl/aqua/inc/saltimer.h ooo_SRC680_m233_src.aquavcl04/vcl/aqua/inc/saltimer.h
--- ooo_SRC680_m233_src.orig/vcl/aqua/inc/saltimer.h	2007-10-09 17:12:00.000000000 +0200
+++ ooo_SRC680_m233_src.aquavcl04/vcl/aqua/inc/saltimer.h	2007-10-15 15:24:24.000000000 +0200
@@ -54,6 +54,10 @@
     
     static void handleStartTimerEvent( NSEvent* pEvent );
 
+
+    static NSTimer* pRunningTimer;
+    static bool bDispatchTimer;
+    static bool bTimerInDispatch;
 };
 
 #endif
diff -x CVS -x wntmsci3 -x wntmsci7 -x wntmsci8 -urN ooo_SRC680_m233_src.orig/vcl/aqua/inc/vclnsapp.h ooo_SRC680_m233_src.aquavcl04/vcl/aqua/inc/vclnsapp.h
--- ooo_SRC680_m233_src.orig/vcl/aqua/inc/vclnsapp.h	1970-01-01 01:00:00.000000000 +0100
+++ ooo_SRC680_m233_src.aquavcl04/vcl/aqua/inc/vclnsapp.h	2007-10-15 15:24:25.000000000 +0200
@@ -0,0 +1,63 @@
+/*************************************************************************
+ *
+ *  OpenOffice.org - a multi-platform office productivity suite
+ *
+ *  $RCSfile$
+ *
+ *  $Revision$
+ *
+ *  last change: $Author$ $Date$
+ *
+ *  The Contents of this file are made available subject to
+ *  the terms of GNU Lesser General Public License Version 2.1.
+ *
+ *
+ *    GNU Lesser General Public License Version 2.1
+ *    =============================================
+ *    Copyright 2005 by Sun Microsystems, Inc.
+ *    901 San Antonio Road, Palo Alto, CA 94303, USA
+ *
+ *    This library is free software; you can redistribute it and/or
+ *    modify it under the terms of the GNU Lesser General Public
+ *    License version 2.1, as published by the Free Software Foundation.
+ *
+ *    This library is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ *    Lesser General Public License for more details.
+ *
+ *    You should have received a copy of the GNU Lesser General Public
+ *    License along with this library; if not, write to the Free Software
+ *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ *    MA  02111-1307  USA
+ *
+ ************************************************************************/
+
+#ifndef _VCL_VCLNSAPP_H
+#define _VCL_VCLNSAPP_H
+
+#include "premac.h"
+#include "Cocoa/Cocoa.h"
+#include "postmac.h"
+ 
+@interface CocoaThreadEnabler : NSObject
+{
+}
+-(void)enableCocoaThreads:(id)param;
+@end
+
+// our very own application
+@interface VCL_NSApplication : NSApplication
+{
+}
+-(void)sendEvent:(NSEvent*)pEvent;
+-(NSMenu*)applicationDockMenu:(NSApplication *)sender;
+-(MacOSBOOL)application: (NSApplication*) app openFile: (NSString*)file;
+-(void)application: (NSApplication*) app openFiles: (NSArray*)files;
+-(MacOSBOOL)application: (NSApplication*) app printFile: (NSString*)file;
+-(NSApplicationPrintReply)application: (NSApplication *) app printFiles:(NSArray *)files withSettings: (NSDictionary *)printSettings showPrintPanels:(MacOSBOOL)bShowPrintPanels;
+-(NSApplicationTerminateReply)applicationShouldTerminate: (NSApplication *) app;
+@end
+
+
+#endif
diff -x CVS -x wntmsci3 -x wntmsci7 -x wntmsci8 -urN ooo_SRC680_m233_src.orig/vcl/aqua/source/app/makefile.mk ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/app/makefile.mk
--- ooo_SRC680_m233_src.orig/vcl/aqua/source/app/makefile.mk	2007-07-05 10:18:05.000000000 +0200
+++ ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/app/makefile.mk	2007-10-17 20:13:38.000000000 +0200
@@ -59,7 +59,10 @@
 OBJFILES=	$(OBJ)$/salmain.obj
 
 SLOFILES=   $(SLO)$/salinst.obj			\
+            $(SLO)$/saldata.obj         \
+            $(SLO)$/vclnsapp.obj        \
 			$(SLO)$/saltimer.obj		\
+			$(SLO)$/salnstimer.obj		\
 			$(SLO)$/salsound.obj		\
 			$(SLO)$/salsys.obj			\
 			$(SLO)$/salmain.obj
diff -x CVS -x wntmsci3 -x wntmsci7 -x wntmsci8 -urN ooo_SRC680_m233_src.orig/vcl/aqua/source/app/saldata.cxx ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/app/saldata.cxx
--- ooo_SRC680_m233_src.orig/vcl/aqua/source/app/saldata.cxx	2007-10-09 17:12:44.000000000 +0200
+++ ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/app/saldata.cxx	2007-10-18 16:05:51.000000000 +0200
@@ -38,39 +38,137 @@
 
 #include "saldata.hxx"
 
-// =======================================================================
-
-#ifdef __cplusplus
-extern "C" {
-#endif // __cplusplus
-
-void SalSetSalData( struct SalData* pData )
+struct curs_ent
 {
-	SetSalData( pData );
+    const char*         pBaseName;
+    const NSPoint       aHotSpot;
 }
-
-// -----------------------------------------------------------------------
-
-struct SalData* SalGetSalData()
+const aCursorTab[ POINTER_COUNT ] =
 {
-	return GetSalData();
-}
-
-// -----------------------------------------------------------------------
+{ NULL, { 0, 0 } }, //POINTER_ARROW
+{ "nullptr", { 16, 16 } }, //POINTER_NULL
+{ "hourglass", { 15, 15 } }, //POINTER_WAIT
+{ NULL, { 0, 0 } }, //POINTER_TEXT
+{ "help", { 0, 0 } }, //POINTER_HELP
+{ NULL, { 0, 0 } }, //POINTER_CROSS
+{ NULL, { 0, 0 } }, //POINTER_MOVE
+{ NULL, { 0, 0 } }, //POINTER_NSIZE
+{ NULL, { 0, 0 } }, //POINTER_SSIZE
+{ NULL, { 0, 0 } }, //POINTER_WSIZE
+{ NULL, { 0, 0 } }, //POINTER_ESIZE
+{ "nwsesize", { 15, 15 } }, //POINTER_NWSIZE
+{ "neswsize", { 15, 15 } }, //POINTER_NESIZE
+{ "neswsize", { 15, 15 } }, //POINTER_SWSIZE
+{ "nwsesize", { 15, 15 } }, //POINTER_SESIZE
+{ NULL, { 0, 0 } }, //POINTER_WINDOW_NSIZE
+{ NULL, { 0, 0 } }, //POINTER_WINDOW_SSIZE
+{ NULL, { 0, 0 } }, //POINTER_WINDOW_WSIZE
+{ NULL, { 0, 0 } }, //POINTER_WINDOW_ESIZE
+{ "nwsesize", { 15, 15 } }, //POINTER_WINDOW_NWSIZE
+{ "neswsize", { 15, 15 } }, //POINTER_WINDOW_NESIZE
+{ "neswsize", { 15, 15 } }, //POINTER_WINDOW_SWSIZE
+{ "nwsesize", { 15, 15 } }, //POINTER_WINDOW_SESIZE
+{ NULL, { 0, 0 } }, //POINTER_HSPLIT
+{ NULL, { 0, 0 } }, //POINTER_VSPLIT
+{ NULL, { 0, 0 } }, //POINTER_HSIZEBAR
+{ NULL, { 0, 0 } }, //POINTER_VSIZEBAR
+{ NULL, { 0, 0 } }, //POINTER_HAND
+{ NULL, { 0, 0 } }, //POINTER_REFHAND
+{ "pen", { 3, 27 } }, //POINTER_PEN
+{ "magnify", { 12, 13 } }, //POINTER_MAGNIFY
+{ "fill", { 10, 22 } }, //POINTER_FILL
+{ "rotate", { 15, 15 } }, //POINTER_ROTATE
+{ "hshear", { 15, 15 } }, //POINTER_HSHEAR
+{ "vshear", { 15, 15 } }, //POINTER_VSHEAR
+{ "mirror", { 14, 12 } }, //POINTER_MIRROR
+{ "crook", { 15, 14 } }, //POINTER_CROOK
+{ "crop", { 9, 9 } }, //POINTER_CROP
+{ "movept", { 0, 0 } }, //POINTER_MOVEPOINT
+{ "movebw", { 0, 0 } }, //POINTER_MOVEBEZIERWEIGHT
+{ "movedata", { 0, 0 } }, //POINTER_MOVEDATA
+{ "copydata", { 0, 0 } }, //POINTER_COPYDATA
+{ "linkdata", { 0, 0 } }, //POINTER_LINKDATA
+{ "movedlnk", { 0, 0 } }, //POINTER_MOVEDATALINK
+{ "copydlnk", { 0, 0 } }, //POINTER_COPYDATALINK
+{ "movef", { 8, 8 } }, //POINTER_MOVEFILE
+{ "copyf", { 8, 8 } }, //POINTER_COPYFILE
+{ "linkf", { 8, 8 } }, //POINTER_LINKFILE
+{ "moveflnk", { 8, 8 } }, //POINTER_MOVEFILELINK
+{ "copyflnk", { 8, 8 } }, //POINTER_COPYFILELINK
+{ "movef2", { 7, 8 } }, //POINTER_MOVEFILES
+{ "copyf2", { 7, 8 } }, //POINTER_COPYFILES
+{ "notallow", { 15, 15 } }, //POINTER_NOTALLOWED
+{ "dline", { 8, 8 } }, //POINTER_DRAW_LINE
+{ "drect", { 8, 8 } }, //POINTER_DRAW_RECT
+{ "dpolygon", { 8, 8 } }, //POINTER_DRAW_POLYGON
+{ "dbezier", { 8, 8 } }, //POINTER_DRAW_BEZIER
+{ "darc", { 8, 8 } }, //POINTER_DRAW_ARC
+{ "dpie", { 8, 8 } }, //POINTER_DRAW_PIE
+{ "dcirccut", { 8, 8 } }, //POINTER_DRAW_CIRCLECUT
+{ "dellipse", { 8, 8 } }, //POINTER_DRAW_ELLIPSE
+{ "dfree", { 8, 8 } }, //POINTER_DRAW_FREEHAND
+{ "dconnect", { 8, 8 } }, //POINTER_DRAW_CONNECT
+{ "dtext", { 8, 8 } }, //POINTER_DRAW_TEXT
+{ "dcapt", { 8, 8 } }, //POINTER_DRAW_CAPTION
+{ "chart", { 15, 16 } }, //POINTER_CHART
+{ "detectiv", { 12, 13 } }, //POINTER_DETECTIVE
+{ "pivotcol", { 7, 5 } }, //POINTER_PIVOT_COL
+{ "pivotrow", { 8, 7 } }, //POINTER_PIVOT_ROW
+{ "pivotfld", { 8, 7 } }, //POINTER_PIVOT_FIELD
+{ "chain", { 0, 2 } }, //POINTER_CHAIN
+{ "chainnot", { 2, 2 } }, //POINTER_CHAIN_NOTALLOWED
+{ "timemove", { 16, 16 } }, //POINTER_TIMEEVENT_MOVE
+{ "timesize", { 16, 17 } }, //POINTER_TIMEEVENT_SIZE
+{ "asn", { 16, 12 } }, //POINTER_AUTOSCROLL_N
+{ "ass", { 15, 19 } }, //POINTER_AUTOSCROLL_S
+{ "asw", { 12, 15 } }, //POINTER_AUTOSCROLL_W
+{ "ase", { 19, 16 } }, //POINTER_AUTOSCROLL_E
+{ "asnw", { 10, 10 } }, //POINTER_AUTOSCROLL_NW
+{ "asne", { 21, 10 } }, //POINTER_AUTOSCROLL_NE
+{ "assw", { 21, 21 } }, //POINTER_AUTOSCROLL_SW
+{ "asse", { 21, 21 } }, //POINTER_AUTOSCROLL_SE
+{ "asns", { 15, 15 } }, //POINTER_AUTOSCROLL_NS
+{ "aswe", { 15, 15 } }, //POINTER_AUTOSCROLL_WE
+{ "asnswe", { 15, 15 } }, //POINTER_AUTOSCROLL_NSWE
+{ "airbrush", { 5, 22 } }, //POINTER_AIRBRUSH
+{ "vtext", { 15, 15 } }, //POINTER_TEXT_VERTICAL
+{ "pivotdel", { 18, 15 } }, //POINTER_PIVOT_DELETE
+{ "tblsels", { 15, 30 } }, //POINTER_TAB_SELECT_S
+{ "tblsele", { 30, 16 } }, //POINTER_TAB_SELECT_E
+{ "tblselse", { 30, 30 } }, //POINTER_TAB_SELECT_SE
+{ "tblselw", { 1, 16 } }, //POINTER_TAB_SELECT_W
+{ "tblselsw", { 1, 30 } }, //POINTER_TAB_SELECT_SW
+{ "pntbrsh", { 9, 16 } }  //POINTER_PAINTBRUSH
+};
 
-struct SalData* SalGetAppSalData()
+NSCursor* SalData::getCursor( PointerStyle i_eStyle )
 {
-	return GetAppSalData();
+    if( i_eStyle >= POINTER_COUNT )
+        return nil;
+    
+    NSCursor* pCurs = maCursors[ i_eStyle ];
+    if( pCurs == INVALID_CURSOR_PTR )
+    {
+        pCurs = nil;        
+        if( aCursorTab[ i_eStyle ].pBaseName )
+        {
+            NSPoint aHotSpot = aCursorTab[ i_eStyle ].aHotSpot;
+            CFStringRef pCursorName =
+                CFStringCreateWithCStringNoCopy(
+                    kCFAllocatorDefault,
+                    aCursorTab[ i_eStyle ].pBaseName,
+                    kCFStringEncodingASCII,
+                    kCFAllocatorNull );
+            CFBundleRef hMain = CFBundleGetMainBundle();
+            CFURLRef hURL = CFBundleCopyResourceURL( hMain, pCursorName, CFSTR("png"), CFSTR("cursors") );
+            if( hURL )
+            {
+                pCurs = [[NSCursor alloc] initWithImage: [[NSImage alloc] initWithContentsOfURL: (NSURL*)hURL] hotSpot: aHotSpot];
+                CFRelease( hURL );
+            }
+            CFRelease( pCursorName );
+        }
+        maCursors[ i_eStyle ] = pCurs;
+    }
+    return pCurs;
 }
-
-// -----------------------------------------------------------------------
-
-BOOL SalGetAppQuit()
-{
-	return ImplGetSVData()->maAppData.mbAppQuit;
-}
-
-#ifdef __cplusplus
-}
-#endif // __cplusplus
-
diff -x CVS -x wntmsci3 -x wntmsci7 -x wntmsci8 -urN ooo_SRC680_m233_src.orig/vcl/aqua/source/app/salinst.cxx ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/app/salinst.cxx
--- ooo_SRC680_m233_src.orig/vcl/aqua/source/app/salinst.cxx	2007-10-09 17:12:57.000000000 +0200
+++ ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/app/salinst.cxx	2007-10-23 16:05:13.000000000 +0200
@@ -57,6 +57,7 @@
 #include "salprn.h"
 #include "salogl.h"
 #include "saltimer.h"
+#include "vclnsapp.h"
 
 #include "premac.h"
 #include <ApplicationServices/ApplicationServices.h>
@@ -75,8 +76,7 @@
 
 // the AppEventList must be available before any SalData/SalInst/etc. objects are ready
 typedef std::list<const ApplicationEvent*> AppEventList;
-static AppEventList aAppEventList;
-
+AppEventList AquaSalInstance::aAppEventList;
 
 NSMenu* AquaSalInstance::GetDynamicDockMenu()
 {
@@ -85,136 +85,6 @@
     return pDockMenu;
 }
  
-@interface CocoaThreadEnabler : NSObject
-{
-}
--(void)enableCocoaThreads:(id)param;
-@end
-
-@implementation CocoaThreadEnabler
--(void)enableCocoaThreads:(id)param
-{
-    // do nothing, this is just to start an NSThread and therefore put
-    // Cocoa into multithread mode
-}
-@end
-
-// our very own application
-@interface VCL_NSApplication : NSApplication
-{
-}
--(void)sendEvent:(NSEvent*)pEvent;
--(NSMenu*)applicationDockMenu:(NSApplication *)sender;
--(MacOSBOOL)application: (NSApplication*) app openFile: (NSString*)file;
--(void)application: (NSApplication*) app openFiles: (NSArray*)files;
--(MacOSBOOL)application: (NSApplication*) app printFile: (NSString*)file;
--(NSApplicationPrintReply)application: (NSApplication *) app printFiles:(NSArray *)files withSettings: (NSDictionary *)printSettings showPrintPanels:(BOOL)bShowPrintPanels;
--(NSApplicationTerminateReply)applicationShouldTerminate: (NSApplication *) app;
-@end
-
-@implementation VCL_NSApplication
--(void)sendEvent:(NSEvent*)pEvent
-{
-    NSEventType eType = [pEvent type];
-    if( eType == NSApplicationDefined )
-        GetSalData()->mpFirstInstance->handleAppDefinedEvent( pEvent );
-    else if( eType == NSKeyDown && ([pEvent modifierFlags] & NSCommandKeyMask) != 0 )
-    {
-        NSWindow* pKeyWin = [NSApp keyWindow];
-        if( pKeyWin && [pKeyWin isKindOfClass: [SalFrameWindow class]] )
-        {
-            AquaSalFrame* pFrame = [(SalFrameWindow*)pKeyWin getSalFrame];
-            if( pFrame->mpParent && pFrame->mpParent->GetWindow()->IsInModalMode() )
-            {
-                // dispatch to view directly to avoid the key event being consumed by the menubar
-                [[pKeyWin contentView] keyDown: pEvent];
-                return;
-            }
-        }
-
-    }
-    [super sendEvent: pEvent];
-}
-
--(NSMenu*)applicationDockMenu:(NSApplication *)sender
-{
-    return AquaSalInstance::GetDynamicDockMenu();
-}
--(MacOSBOOL)application: (NSApplication*)app openFile: (NSString*)pFile
-{
-    const rtl::OUString aFile( GetOUString( pFile ) );
-	const ApplicationEvent* pAppEvent = new ApplicationEvent( String(), ApplicationAddress(),
-                                                APPEVENT_OPEN_STRING, aFile );
-	aAppEventList.push_back( pAppEvent );
-    return YES;
-}
-
--(void)application: (NSApplication*) app openFiles: (NSArray*)files
-{
-    rtl::OUStringBuffer aFileList( 256 );
-    
-    NSEnumerator* it = [files objectEnumerator];
-    NSString* pFile = nil;
-    
-    while( (pFile = [it nextObject]) != nil )
-    {
-        if( aFileList.getLength() > 0 )
-            aFileList.append( sal_Unicode( APPEVENT_PARAM_DELIMITER ) );
-        aFileList.append( GetOUString( pFile ) );
-    }
-    // we have no back channel here, we have to assume success, in which case
-    // replyToOpenOrPrint does not need to be called according to documentation
-    // [app replyToOpenOrPrint: NSApplicationDelegateReplySuccess];
-	const ApplicationEvent* pAppEvent = new ApplicationEvent( String(), ApplicationAddress(),
-                                                APPEVENT_OPEN_STRING, aFileList.makeStringAndClear() );
-	aAppEventList.push_back( pAppEvent );
-}
-
--(MacOSBOOL)application: (NSApplication*)app printFile: (NSString*)pFile
-{
-    const rtl::OUString aFile( GetOUString( pFile ) );
-	const ApplicationEvent* pAppEvent = new ApplicationEvent( String(), ApplicationAddress(),
-                                                APPEVENT_PRINT_STRING, aFile );
-	aAppEventList.push_back( pAppEvent );
-    return YES;
-}
--(NSApplicationPrintReply)application: (NSApplication *) app printFiles:(NSArray *)files withSettings: (NSDictionary *)printSettings showPrintPanels:(BOOL)bShowPrintPanels
-{
-    // currently ignores print settings an bShowPrintPanels
-    rtl::OUStringBuffer aFileList( 256 );
-    
-    NSEnumerator* it = [files objectEnumerator];
-    NSString* pFile = nil;
-    
-    while( (pFile = [it nextObject]) != nil )
-    {
-        if( aFileList.getLength() > 0 )
-            aFileList.append( sal_Unicode( APPEVENT_PARAM_DELIMITER ) );
-        aFileList.append( GetOUString( pFile ) );
-    }
-	const ApplicationEvent* pAppEvent = new ApplicationEvent( String(), ApplicationAddress(),
-                                                APPEVENT_PRINT_STRING, aFileList.makeStringAndClear() );
-	aAppEventList.push_back( pAppEvent );
-    // we have no back channel here, we have to assume success
-    // correct handling would be NSPrintingReplyLater and then send [app replyToOpenOrPrint]
-    return NSPrintingSuccess;
-}
-
--(NSApplicationTerminateReply)applicationShouldTerminate: (NSApplication *) app
-{
-    const SalData* pSalData = GetSalData();
-	if( !pSalData->maFrames.empty() )
-    {
-        // we forward the signal; alas we have no answer
-        // we cancel the request; OOo will decide whether is shuts down or not
-		pSalData->maFrames.front()->CallCallback( SALEVENT_SHUTDOWN, NULL );
-        return NSTerminateCancel;
-    }
-    else
-        // no frame left to talk to -> we really should terminate
-        return NSTerminateNow;
-}
-@end
 
 // initialize the cocoa VCL_NSApplication object
 // returns an NSAutoreleasePool that must be released when the event loop begins
@@ -518,6 +388,7 @@
 	mpSalYieldMutex->acquire();
     maMainThread = vos::OThread::getCurrentIdentifier();
     mnMainThreadLevel = 0;
+    mbWaitingYield = false;
     mpAutoreleasePool = nil;
     maUserEventListMutex = osl_createMutex();
 }
@@ -533,25 +404,36 @@
 
 // -----------------------------------------------------------------------
 
+void AquaSalInstance::wakeupYield()
+{
+    // wakeup :Yield
+    if( mbWaitingYield )
+    {
+        NSPoint aPt = { 0, 0 };
+        NSEvent* pEvent = [NSEvent otherEventWithType: NSApplicationDefined
+                                   location: aPt
+                                   modifierFlags: 0
+                                   timestamp: 0
+                                   windowNumber: 0
+                                   context: nil
+                                   subtype: AquaSalInstance::YieldWakeupEvent
+                                   data1: 0
+                                   data2: 0 ];
+        if( pEvent )
+            [NSApp postEvent: pEvent atStart: NO];
+    }
+}
+
+// -----------------------------------------------------------------------
+
 void AquaSalInstance::PostUserEvent( AquaSalFrame* pFrame, USHORT nType, void* pData )
 {
     osl_acquireMutex( maUserEventListMutex );
     maUserEvents.push_back( SalUserEvent( pFrame, pData, nType ) );
     osl_releaseMutex( maUserEventListMutex );
-    // wakeup :Yield
-    NSPoint aPt = { 0, 0 };
-    NSEvent* pEvent = [NSEvent otherEventWithType: NSApplicationDefined
-                               location: aPt
-                               modifierFlags: 0
-                               timestamp: 0
-                               windowNumber: 0
-                               context: nil
-                               subtype: AquaSalInstance::YieldWakeupEvent
-                               data1: 0
-                               data2: 0 ];
-    if( pEvent )
-        [NSApp postEvent: pEvent atStart: NO];
-
+    
+    // notify main loop that an event has arrived
+    wakeupYield();
 }
 
 // -----------------------------------------------------------------------
@@ -650,7 +532,7 @@
     
         // get one user event
         osl_acquireMutex( maUserEventListMutex );
-        SalUserEvent aEvent( NULL, 0, NULL );
+        SalUserEvent aEvent( NULL, NULL, 0 );
         if( ! maUserEvents.empty() )
         {
             aEvent = maUserEvents.front();
@@ -700,6 +582,8 @@
         // if we had no event yet, wait for one if requested
         if( bWait && ! bHadEvent )
         {
+            bool bOldWaitingYield = mbWaitingYield;
+            mbWaitingYield = true;
             ULONG nCount = ReleaseYieldMutex();
     
             pEvent = [NSApp nextEventMatchingMask: NSAnyEventMask untilDate: [NSDate distantFuture]
@@ -709,6 +593,7 @@
             [NSApp updateWindows];
         
             AcquireYieldMutex( nCount );
+            mbWaitingYield = bOldWaitingYield;
         }
         
         mnMainThreadLevel--;
